function visclass_gui_call_back(s,class)
//-----------------------------------------------------------------------  
// function visclass_gui_call_back(s,class)
//
// The callback function used in visclass('gui')
//
// not to be used outside the function: visclass('gui')
//
//-----------------------------------------------------------------------  
//   $RCSfile: visclass_gui_call_back.sci,v $
//  $Revision: 1.3 $
//      $Date: 2003/10/21 17:33:13 $
//  Copyright: IIF-LMB $Author: haasdonk $
//
//-----------------------------------------------------------------------
//  $Log: visclass_gui_call_back.sci,v $
//  Revision 1.3  2003/10/21 17:33:13  haasdonk
//  *** empty log message ***
//
//  Revision 1.2  2003/10/16 15:05:33  haasdonk
//  minor changes for suitability with Scilab Version 2.7
//
//  Revision 1.1  2003/10/16 12:16:46  haasdonk
//  initial version after release of presto-box 1.0, after rename of old
//  repository patrec-lib
//
//  Revision 1.2  2002/09/10 18:17:47  poluru
//  eroor modification
//
//  Revision 1.1  2002/09/10 15:15:36  poluru
//  "macros" directory structure is created
//
//-----------------------------------------------------------------------

  
//recognizing the current figure 
  f= findobj( 'tag','visclass_gui_f_fig');  
  
  //recognizing the push buttons
  col  = findobj( 'tag','visclass_gui_col');
  puCC = findobj( 'tag','visclass_gui_pucc');
  puRGB= findobj( 'tag','visclass_gui_purgb');  
  sh   = findobj( 'tag','visclass_gui_sh');
  puSH = findobj( 'tag','visclass_gui_pudh');
  puD  = findobj( 'tag','visclass_gui_pud');
  puH  = findobj( 'tag','visclass_gui_puh');
  puE  = findobj( 'tag','visclass_gui_pue');
    
  //recognizing the edit fields
  e1= findobj( 'tag','visclass_gui_e1');
  e21= findobj( 'tag','visclass_gui_e21');
  e22= findobj( 'tag','visclass_gui_e22');
  e31= findobj( 'tag','visclass_gui_e31');
  e32= findobj( 'tag','visclass_gui_e32');
  e41= findobj( 'tag','visclass_gui_e41');
  e42= findobj( 'tag','visclass_gui_e42');
  e5 = findobj( 'tag','visclass_gui_e5');
  e5R= findobj( 'tag','visclass_gui_e5r');
  e5G= findobj( 'tag','visclass_gui_e5g');
  e5B= findobj( 'tag','visclass_gui_e5b');
  e6 = findobj( 'tag','visclass_gui_e6');
  cbPP = findobj( 'tag','visclass_gui_cbpp');
  cb2d = findobj( 'tag','visclass_gui_cb2d');
  cb3d = findobj( 'tag','visclass_gui_cb3d');
  
  //retriving the data from the global variables
  global  param param1
  //classifier=get(f,'data') ;
  execstr('global '+param1);
  execstr(param+ '=' + param1);
  
  if s=='cc_slider',
    cnum=evstr(get(col,'value'));  
    // global colm
// $$$     disp(cnum);disp(size(colm))
    set(e5,'string',string(cnum));
    set(e5R,'string',string(colm(cnum,1)));
    set(e5G,'string',string(colm(cnum,2)));
    set(e5B,'string',string(colm(cnum,3)));
        
    execstr('fig_colm_'+string(f)+' =' +'colm');
    
  else
    if s=='cc_button',
      CNUM=evstr(get(col,'value'));  
      
      if get(e5,'string')~="s",
      	[cnum,enum]=evstr(get(e5,'string'));
	// global colm col_no
	if enum==0 & type(cnum)~=10 & length(cnum)==1 ,
	  if length(cnum)~=0
	    if pmodulo(cnum,1)~=0,
	      cnum=round(cnum);
	      set(e5,'string',string(cnum));
	    end
	    
	    if cnum > col_no;
	      colm(col_no+1:cnum,:) = 0;	  
	      set(col,'max',cnum);
	      col_no=cnum;
	    end
	    
	    set(col,'value',cnum);
	    set(e5R,'string',string(colm(cnum,1)));
	    set(e5G,'string',string(colm(cnum,2)));
	    set(e5B,'string',string(colm(cnum,3)));
	  else 	
	    x_message('enter some value for classnumber ');
	    set(e5,'string',string(CNUM));
	  end      
	else 	
	  x_message('classnumber must be numerical value');
	  set(e5,'string',string(CNUM));
	end 	
      else
	x_message('classnumber must be numerical value');
	set(e5,'string',string(CNUM));	      
      end
      
      execstr('fig_colm_'+string(f)+' =' +'colm');
      execstr('fig_col_no_'+string(f)+' =' +'col_no');
    else
      if s=='rgb_button',
	cnum=evstr(get(col,'value'));
	[R,eR]=evstr(get(e5R,'string'));
	[G,eG]=evstr(get(e5G,'string'));
	[B,eB]=evstr(get(e5B,'string')); 
	
	if eR==0 & type(R)~=10 & length(R)==1,
	  if R>1|R<0 |length(R)==0
	    x_message('R,G,B values should be in the range:[0,1]');
	    set(e5R,'string',string(colm(cnum,1)));
	  else
	    colm(cnum,1)=R
	  end
	else
	  x_message('enter numerical values for R,G,B');
	  set(e5R,'string',string(colm(cnum,1)));
	end
	
	if eG==0 & type(G)~=10 & length(G)==1
	  if G>1|G<0|length(G)==0
	    x_message('R,G,B values should be in the range:[0,1]');
	    set(e5G,'string',string(colm(cnum,2)));
	  else
	    colm(cnum,2)=G
	  end
	else
	   x_message('enter numerical values for R,G,B');
	  set(e5G,'string',string(colm(cnum,2)));
	end
	
	if eB==0& type(B)~=10 & length(B)==1,
	  if B>1|B<0|length(B)==0
	    x_message('R,G,B values should be in the range:[0,1]'); 
	    set(e5B,'string',string(colm(cnum,3)));
	  else
	    colm(cnum,3)=B
	  end
	else
	  x_message('enter numerical values for R,G,B');
	  set(e5B,'string',string(colm(cnum,3)));
	end  
			
	execstr('fig_colm_'+string(f)+' =' +'colm');
	
      else
	if s=='sh_slider',
	  if sh_slider_lock ==0
	    sh_slider_lock=1
	    nshades=evstr(get(sh,'value'));
	    set(e6,'string',string(nshades));
	    sh_slider_lock=0
	  end
	    execstr('fig_nshades_'+string(f)+' =' +'nshades');
	    execstr('fig_sh_slider_lock_'+string(f)+' ='+ ...
		    'sh_slider_lock');	    
	else
	  if s=='sh_button',
	    
	    if get(e6,'string')~="s" ,
	      [nsh,esh]=evstr(get(e6,'string'));
	      if esh==0 & type(nsh)~=10 & length(nsh)==1, 
		if length(nsh)~=0
		  if nsh>100  
		    x_message('Number of shades can be atmost 100');
		    set(e6,'string',string(nshades));
		  else
		    if nsh<2, 
		      x_message('Number of shades should be atleast 2');
		      set(e6,'string',string(nshades));
		    else
		      nshades=nsh;
		      set(sh,'value',nshades);
		    end
		  end
		else
		  x_message('Enter some Value for shades');
		  set(e6,'string',string(nshades));
		end
	      else
		x_message('Enter a numerical Value for shades');
		set(e6,'string',string(nshades));
	      end
	    else
	      x_message('Enter a numerical Value for shades');
	      set(e6,'string',string(nshades));
	    end
	    
	    execstr('fig_nshades_'+string(f)+' =' +'nshades');
	    
	  else
	    if s=='draw',
	      
	      str=get(e1,'string');
	      lstr=length(str);	      
	      ind=strindex(str,',');
	      if length(lstr)==0 |length(ind)==0| ind(1)==1|ind($)==lstr
		x_message('Error in the origin: see help ');
		ori=strcat(string(origin),',');
		set(e1,'string',ori(1));
	      else
		ind1=[1,ind+1];
		ind2=[ind-1,length(str)];
		
		execstr('vect=['+strcat('part(str,'+string(ind1)+ ...
					':'+string(ind2)+')',',')+']');
		
		[Ori,eo]=evstr(vect(:));
		
		if eo ==0,
		  if length(Ori)<2
		    x_message('Length of origin should be atleast 2');
		    ori=strcat(string(origin),',');
		    set(e1,'string',ori(1));
		  else
		    if length(Ori)~=DIM
		      x_message(['Length of origin i.e. the dimension of'; 
				 'data shouldn''t be altered in this demo']);
		      ori=strcat(string(origin),',');
		      set(e1,'string',ori(1));
		    else
		      origin=Ori;
		    end   
		  end
		else
		  x_message('Enter numerical values seperated "+...
			    "by commas for origin');
		  
		  ori=strcat(string(origin),',');
		  set(e1,'string',ori(1));
		end
	      end
              
	      //projections from the edit field
	      [pro1,ep1]=evstr(get(e21,'string')); 
	      [pro2,ep2]=evstr(get(e22,'string'));
	      
	      if ep1 ==0 & type(pro1)~=10 & length(pro1)==1,
		if pro1>DIM, 
		  x_message(['Error in projection1 it should be';
			     'less than the length of origin']);
		  set(e21,'string',string(p1));
		else
		  if pmodulo(pro1,1)~=0
		    pro1 = round(pro1); 
		    set(e21,'string',string(pro1));
		  end
		  p1=pro1;
		end
	      else
		x_message('Error in the value given for projection1');
		set(e21,'string',string(p1));
	      end
	      
	      if ep2 ==0 & type(pro2)~=10 & length(pro2)==1,
		if pro2 > DIM,
		  x_message(['Error in projection2 it should be';
			     'less than the length of origin']);
		  set(e22,'string',string(p2));
		else
		  if pmodulo(pro2,1)~=0
		    pro2 = round(pro2); 
		    set(e22,'string',string(pro2));
		  end
		  p2=pro2;
		end
	      else	
		x_message('Error in the value given for projection2');
		set(e22,'string',string(p2));
	      end
	      
	      //size from the edit field
	      
	      [si1,esi1]=evstr(get(e31,'string')); 
	      [si2,esi2]=evstr(get(e32,'string'));
	      
	      if esi1 ==0 & type(si1)~=10 & length(si1)==1,
		if pmodulo(si1,1)~=0
		  si1 = round(si1); 
		  set(e31,'string',string(si1));
		end
		Size(1) = si1;      
	      else
		x_message('Error in the value given for Size1');
		set(e31,'string',string(Size(1)));
	      end
	      
	      if esi2 ==0 & type(si2)~=10 & length(si2)==1,
		if pmodulo(si2,1)~=0
		  si2 = round(si2); 
		  set(e32,'string',string(si2));
		end      
		Size(2) = si2;      
	      else
		x_message('Error in the value given for Size2');
		set(e32,'string',string(Size(2)));
	      end
	      
	      //resolution from the edit field
	      [re1,ere1]=evstr(get(e41,'string')); 
	      [re2,ere2]=evstr(get(e42,'string'));
	      
	      if ere1 ==0 & type(re1)~=10 & length(re1)==1,   
		if pmodulo(re1,1)~=0
		  re1 = round(re1); 
		  set(e41,'string',string(re1));
		end
		resol(1) = re1
	      else
		x_message('Error in the value given for resolution1');
		set(e41,'string',string(resol(1)));
	      end
	      
	      if ere2 ==0& type(re2)~=10 & length(re2)==1, 
		if pmodulo(re2,1)~=0
		  re2 = round(re2); 
		  set(e42,'string',string(re2));
		end
		resol(2) = re2;      
	      else
		x_message('Error in the value given for resolution2');
		set(e42,'string',string(resol(2)));
	      end
	      
	      if evstr(get(cb2d,'value'))==1,
		dimension='''2d'',''shades'',nshades';
		dim="2d";
	      else
		dimension='''3d''';
		dim="3d";
	      end
	      
	      if evstr(get(cbPP,'value'))==1 & dim=="2d",
		dimension=dimension+',''plot_points'',plot_points,plot_labels';	
	      end
	      execstr('c'+string([1:col_no]')+'=colm('+ ...
		      string([1:col_no]')+',:)');      
	      
	      cmap='""class_color"",'+string([1:col_no]')+','+'c'+ ...
		   string([1:col_no]');
	      
	      cmap=strcat(cmap,',');
	      xbasc();
	      xname('visclass(""'+dim+'"")');
	      vis= 'visclass(''origin'',origin,''projections'',"+...
		   "p1,p2, ''size'',Size, ''resolution'',resol,'+ ...
		   dimension+','+cmap+',''classifier'',classifier,varlist(:))';
	      
	      xbasc();
	      execstr(vis); 
	      execstr(param1+ '=' + param);
	    
	    else   
	      	      
	      //help button
	      if s=='help',
		txt = ['This gui allows to interactively set the visualization-parameters for'; ...
	               'classification results which are given by the argument list of the'; ...
		       'invoicing ""visclass"" command. The classification results on an arbitrary'; ...
		       'axis-parallel rectangle in arbitrary n-dimensional feature-space are' ; ...
		       'illustrated. The rectangle is specified by an n-dimensional vector ""origin"",' ; ...
		       'the 2 ""projection""-directions (integers between 1 and n) and the ""size"" of the'; ... 
		       'rectangle in these both directions starting from the origin. ""resolution"" '; ...
		       'defines the direction-wise number of test-points extracted from this rectangle.'; ...
		       ' '; ...
		       
		       'Pressing ""draw"" will perform a new classification of these test-points'; ... 
		       'with the classifier passed to visclass by the argument list.'; ...
		       'The results of the classification are supposed to be class-estimates and'; ...
		       'certainties between 0 and 1 for all test-points.'; ...
		       '""2d-mode"" results in a color-shaded rectangle: the classes are represented by'; ... 
		       'different colors, the certainties by different shading-intensities.'; ... 
		       'In non-""2d-mode"" the results are displayed by a colored function-graph in 3D:'; ... 
		       'the classes are again represented by different colors, the intensities as the'; ... 
		       'height of the function-graph.'; ...   
		       ' '; ...
		       
		       'The class-colors can be edited by choosing a ""class-color number"" either by'; ... 
		       'slider or the corresponding edit-field. After pressing the ""set"" button the'; ... 
		       'current color will be displayed by its rgb-components and can be edited. After'; ... 
		       'pressing the color-""set"" button, this color is saved in the colormap to be'; ... 
		       'used for the next drawing. The number of ""shades"" can be adjusted by a'; ... 
		       'corresponding edit-field or slider. If the checkbox ""plot points"" is set and'; ... 
		       'list of points is passed by the argument list, these points are displayed'; ... 
		       'additionally in the 2D-mode.'];	
		
		x_message(txt);
		
		//exit button
	      else 
		if s=='exit',
		  
		  WI=winsid();
		  if or(WI(1:$)==wi),
		    xdel(wi);
		  end;		  
		  close(f);
		  clear f
		  WI1 = winsid();
		  xpause(1000);		  
		  WI2 = winsid();
		  if length(WI2) > length(WI1),
		    xdel(WI2(1));
		  end;
		  
		  execstr('clearglobal('''+param+''')');
		  execstr('clearglobal('''+param1+''')');
		  clearglobal param;
		  clearglobal param1;
		  
		  if recall=='yes',
		    global visclass_lock; 
		    ptrec_demos_lock=1;
		    visclass_demos_lock = 0;
		    visclass_demos_lock = return(visclass_demos_lock);
		  else 
		    //global vis_gui_lock;
		    set(f,'vis_gui_lock',0);		    
		  end;		  
		end;
	      end;
	    end;
	  end;
	end;
      end;
    end;
  end;
  
endfunction
