.TH RT_ZS  "July 2002" "Presto Group" "scilab function"
.so ../sci.an

.SH NAME 
RT_ZS - 2d-translation-invariant CT_ZS-transformation using + and difference

.SH CALLING SEQUENCE
.nf
res = RT_ZS(x)
.fi

.SH PARAMETERS
.TP 10
x    :
a matrix to be processed by the RT_ZS.
.TP 10
res  :       
matrix of the result of the RT_ZS transformation of x.

.SH DESCRIPTION
\fVRT_ZS\fR (is a matrix transformation) performs CT_ZS transformation i.e. 
first columns are processed and then rows) using the commutative functions
pairwise-addition and absolute-difference on the given matrix x.

.SH EXAMPLE 
.nf 
x = [1 2; 3 4];
res = RT_ZS(x);  
.fi

.SH SEE ALSO
CT, CT_DI, CT_SZ, CT_ZS, MT, MT_DI, MT_SZ, MT_ZS, 
QT, QT_DI, QT_SZ, QT_ZS, RT, RT_DI, RT_SZ

.SH AUTHOR
Bernard Haasdonk

