function demo_plotpolsequence()
//-----------------------------------------------------------------------  
// function demo_plotpolsequence()
//
//  a demonstration(with examples) of plotpolsequence()
//  used internally in patrec_demos(), or Demos button
//   
// input:    none
//
// output:   none
//
//-----------------------------------------------------------------------  
//   $RCSfile: demo_plotpolsequence.sci,v $
//  $Revision: 1.1 $
//      $Date: 2003/10/16 12:16:46 $
//  Copyright: IIF-LMB $Author: haasdonk $
//
//-----------------------------------------------------------------------
//  $Log: demo_plotpolsequence.sci,v $
//  Revision 1.1  2003/10/16 12:16:46  haasdonk
//  initial version after release of presto-box 1.0, after rename of old
//  repository patrec-lib
//
//  Revision 1.2  2002/09/10 16:43:22  poluru
//  added library stuff and errors check
//
//  Revision 1.1  2002/09/10 15:15:36  poluru
//  "macros" directory structure is created
//
//-----------------------------------------------------------------------
 

  mode(-1)
  oldln=lines();
  lines(0)
  deff('[]=demoex4(num)','execstr(demo4(num,2))')
  
  demo4=[
      'plotpolseq() -4 plots'; 
      'plotpolseq() -5 plots';      
      'plotpolseq() -6 plots';      
      'plotpolseq() -7 plots';      
      'plotpolseq() -8 plots';      
	];
  s=string([3:10]');
  S='polstar('+s+',4,2), ''polstar with '+s+' arms''';  
  num=1;
  global patrec_demos_lock;
 
  while %t  then
    num=x_choose(demo4,'plot polygon sequence');
    if num==0 then 
      lines(oldln(1))
      patrec_demos_lock = 0;
      patrec_demos_lock = return(patrec_demos_lock);
      return
    else      
      str= 'plotpolseq('+strcat(S(1:num+2)+', ')+ S(num+3)+')';
      mprintf('\n'+str+'\n');        
      xselect(); xbasc();
      xname('plotpolseq');
      execstr(str);
      return(demo_plotpolsequence());      
    end
    
  end

endfunction

