function res= getmatrix(fig,v)
//-----------------------------------------------------------------------  
//function getmatrix(fig,v,n,as)
//
//a function for getting the user defined data in the figure f
//
// input:    fig          tag/handle of the object figure
//   
//           v            reference for the data to be retrieved
//
//           as           data to be retrieved as: 'matrix'/ 'vector'       
//
// output:   res          either 'matrix' or 'vector': user choice
//-----------------------------------------------------------------------  
//   $RCSfile: getmatrix.sci,v $
//  $Revision: 1.1 $
//      $Date: 2003/10/16 12:16:46 $
//  Copyright: IIF-LMB $Author: haasdonk $
//
//-----------------------------------------------------------------------
//  $Log: 
//-----------------------------------------------------------------------

  [out, in] = argn(0);
  if in ~=2,
    error('wrong number of input arguments.');
  end;
  f=fig;
  
  l_get = list();
  L_tot = 0; L = 0; tv = [];
  n = evstr(get(f,'numdiv'+v));
  s1 = evstr(get(f,'size_data1'+v));
  s2 = evstr(get(f,'size_data2'+v));
     
  if n>1,
    for i=1:n,
      l_get(i) = get(f,v+string(i));
      L = length(l_get(i));
      L_tot = L_tot + L;
      
      execstr("tv"+string(i)+string([1:L]')+"= l_get(i)("+string([1:L]')+');');
      execstr("tv"+string(i)+"= evstr(["+strcat("tv"+string(i)+string([1:L]),',')+"])");
      execstr("tv = [tv, tv"+string(i)+"]");
  
    end;    
  else
    if n==0 | n==1,
      l_get = get(f,v);
      L_tot=length(l_get);
           
      for j=1:L_tot,
	tv=[tv,l_get(j)];
      end;
    end;
  end;
  k=1;
 
  for i=1:s1,
    
    mat(i,1:s2)=tv((i-1)*s2+1:i*s2);
  end;
  res=evstr(mat);

endfunction
