.TH MT_ZS  "July 2002" "Presto Group" "scilab function"
.so ../sci.an

.SH NAME
MT_ZS - 2d-translation-invariant CT_ZS-transformation using max and min.

.SH CALLING SEQUENCE
.nf
res = MT_ZS(x )
.fi

.SH PARAMETERS
.TP 10
x    :      
matrix to be processed by the MT_ZS.
.TP 10
res  :       
matrix of the MT_ZS transformation of x.

.SH DESCRIPTION
\fVMT_ZS\fR (is a matrix transformation) performs CT_ZS transformation i.e. 
first columns are processed and then rows) using the commutative functions
pairwise-maximum and pairwise-minimum, on the given matrix x.

.SH EXAMPLE 
.nf 
x = [1 2; 3 4];
res = MT_ZS(x);  
.fi

.SH SEE ALSO
CT, CT_DI, CT_SZ, CT_ZS, MT, MT_DI, MT_SZ, QT, 
QT_DI, QT_SZ, QT_ZS, RT, RT_DI, RT_SZ, RT_ZS

.SH AUTHOR
Bernard Haasdonk

