.TH polygon  "July 2002" "Presto Group" "scilab function"
.so ../sci.an

.SH NAME 
polygon - converts a complex-valued vector to a real-valued matrix

.SH CALLING SEQUENCE
.nf
res = polygon(cpol)
.fi

.SH PARAMETERS
.TP 10
cpol  :      
a vector(of length n) of complex values
.TP 10
res   :      
a 2*n matrix of real values

.SH DESCRIPTION
\fVcpolygon\fR converts a complex vector of length n to a 2*n matrix of 
real values.

.SH EXAMPLE 
.nf 
cpol = [1+2*%i,2+2*%i,3+2*%i,4+2*%i,5+2*%i,6+2*%i];
res = polygon(cpol);  
.fi

.SH SEE ALSO
cpolygon 

.SH AUTHOR
Bhaskara Reddy Poluru


